package com.tutk.IOTC;

import com.tutk.IOTC.util.LoadLibrary;

public class P2PTunnelAPIs {

	public IP2PTunnelCallback mSelf = null;
	//======================================================================
	public static final int API_ER_ANDROID_NULL				=-100000;
	
	//P2PTunnelAPIs error code======================================================================
	/** The function is performed successfully. */
	public static final int	TUNNEL_ER_NoERROR				=0;

	/** P2PTunnel module is not initialized yet. Please use P2PTunnelServerInitialize() or
	* P2PTunnelAgentInitialize() for initialization. */
	public static final int	TUNNEL_ER_NOT_INITIALIZED		=-30000;
	
	/** The number of P2PTunnel port mapping service has reached maximum.
	* The maximum number of P2PTunnel port mapping service is determined by
	* #TUNNEL_MAX_PORT_MAPPING_SERVICE_NUMBER */
	public static final int	TUNNEL_ER_EXCEED_MAX_SERVICE	=-30001;
	
	/** Failed to start port mapping when binding because local port had been used by
	* the other service in agent side */
	public static final int	TUNNEL_ER_BIND_LOCAL_SERVICE	=-30002;
	
	/** Failed to start port mapping when listening because local port has been used
	* by the other service in agent side */
	public static final int	TUNNEL_ER_LISTEN_LOCAL_SERVICE	=-30003;
	
	/** P2PTunnel module fails to create threads. Please check if OS has ability
	* to create threads for P2PTunnel module. */
	public static final int	TUNNEL_ER_FAIL_CREATE_THREAD	=-30004;
	
	/** Tunnel agent has already connected to a tunnel server, therefore, it failed
	* connect to another tunnel server */
	public static final int	TUNNEL_ER_ALREADY_CONNECTED		=-30005;
	
	/** The tunnel between tunnel agent and tunnel server has been disconnected.
	* Used in tunnel status callback function for notifying tunnel connection status */
	public static final int	TUNNEL_ER_DISCONNECTED			=-30006;
	
	/** The P2PTunnel module has been initialized in a tunnel server or a tunnel agent */
	public static final int	TUNNEL_ER_ALREADY_INITIALIZED	=-30007;
	
	/** Failed to connect to tunnel server because authentication data is wrong. */
	public static final int	TUNNEL_ER_AUTH_FAILED			=-30008;
	
	/** Authentication data length exceed #MAX_AUTH_DATA_LEN. */
	public static final int	TUNNEL_ER_EXCEED_MAX_LEN		=-30009;
	
	/** The specified P2PTunnel session ID is not valid */
	public static final int	TUNNEL_ER_INVALID_SID			=-30010;
	
	/** This UID is illegal. */
	public static final int	TUNNEL_ER_UID_UNLICENSE			=-30011;
	
	/** The specified device does not support advance function
	*(TCP relay and P2PTunnel module) */
	public static final int	TUNNEL_ER_UID_NO_PERMISSION		=-30012;
	
	/** This UID can't setup connection through relay. */
	public static final int	TUNNEL_ER_UID_NOT_SUPPORT_RELAY	=-30013;
	
	/** Tunnel server not login to IOTC server. */
	public static final int	TUNNEL_ER_DEVICE_NOT_ONLINE		=-30014;
		
	/** Tunner server is not listening for connections. */
	public static final int	TUNNEL_ER_DEVICE_NOT_LISTENING	=-30015;
		
	/** Internet not available or firewall block. */
	public static final int	TUNNEL_ER_NETWORK_UNREACHABLE	=-30016;
		
	/** Tunnel agent failed to connect to tunnel server maybe network unstable. */
	public static final int	TUNNEL_ER_FAILED_SETUP_CONNECTION	=-30017;
		
	/** Tunnel server failed to login to IOTC Server but still can be connected by tunnel agent on LAN. */
	public static final int	TUNNEL_ER_LOGIN_FAILED				=-30018;
		
	/** Notify tunnel server session connection alreay reached maximum through tunnelStatusCB,
	* can't be connected anymore until anyone session release. */
	public static final int	TUNNEL_ER_EXCEED_MAX_SESSION		=-30019;
	
	/** Tunnel agent can't call P2PTunnelServer_GetSessionInfo() */
	public static final int	TUNNEL_ER_AGENT_NOT_SUPPORT			=-30020;
	
	/** The arguments passed to a function is invalid. */
	public static final int	TUNNEL_ER_INVALID_ARG               =-30021;
	
	/** OS resource not enough to malloc memory or open socket. */
	public static final int	TUNNEL_ER_OS_RESOURCE_LACK          =-30022;

	/** Tunnel Agent isn't connecting. */
	public static final int	TUNNEL_ER_AGENT_NOT_CONNECTING      =-30023;
    
	/** Unable to get free session.*/
	public static final int	TUNNEL_ER_NO_FREE_SESSION           =-30024;

	/** Connection cancelled*/
	public static final int	TUNNEL_ER_CONNECTION_CANCELLED      =-30025;

	/** The API operation is invalid*/
	public static final int	TUNNEL_ER_OPERATION_IS_INVALID		=-30026;

	/** P2PTunnel handshake failed. */
	public static final int	TUNNEL_ER_HANDSHAKE_FAILED			=-30027;
    
	/** Remote P2PTunnel not support DTLS. */
	public static final int	TUNNEL_ER_REMOTE_NOT_SUPPORT_DTLS	=-30028;

    /** Remote P2PTunnel need connect with DTLS. */
	public static final int	TUNNEL_ER_LOCAL_NOT_SUPPORT_DTLS	=-30029;

    /** API timeout*/
	public static final int	TUNNEL_ER_TIMEOUT					=-30030;

	/** The remote site already closes the IOTC session.*/
	public static final int	TUNNEL_ER_SESSION_CLOSE_BY_REMOTE	=-30031;

	/** This IOTC session is disconnected */
	public static final int	TUNNEL_ER_REMOTE_TIMEOUT_DISCONNECT	=-30032;

	/** API or remote reject*/
	public static final int	TUNNEL_ER_REJECT					=-30033;

	/** retry API*/
	public static final int	TUNNEL_ER_RETRY						=-30034;

	/** init other module fail */
	public static final int	TUNNEL_ER_INIT_OTHER_MODULE_FAIL	=-30035;

	/** Remote P2PTunnel not support this feature */
	public static final int	TUNNEL_ER_REMOTE_NOT_SUPPORT		=-30036;

	public static final int	TUNNEL_ER_UNDEFINED					=-31000;

	 		
	@Deprecated public native static int P2PTunnel_Version();
	public native static String P2PTunnel_Version_String();
	public native int P2PTunnel_LastIOTime(int SID);
    public native int P2PTunnel_Set_Log_Attr(St_LogAttr logAttr);
	public native int P2PTunnel_SetBufSize(int SID, int size);

	public native int  P2PTunnelServerInitialize(int maxConnectionAllowed); //define Server max connection number
	public native int  P2PTunnelServerDeInitialize();
	@Deprecated public native int  P2PTunnelServer_Start(String UID);
	public native void P2PTunnelServer_Stop();
	public native int  P2PTunnelServer_Disconnect(int SID);

	public native int  P2PTunnelAgentInitialize(int maxConnectionAllowed); // only support one sesseion connection
	public native int  P2PTunnelAgentInitialize2(int maxConnectionAllowed, int enableLanDirect); 
	public native int  P2PTunnelAgentDeInitialize();
	@Deprecated public native int  P2PTunnelAgent_Connect(String UID, byte[] authData, int authDataLength, int[] errFromDeviceCB);
	@Deprecated public native int  P2PTunnelAgent_Connect_Parallel(String UID, int SID, byte[] authData, int authDataLength, int[] errFromDeviceCB);
	public native int  P2PTunnelAgent_GetFreeSession();
	public native int  P2PTunnelAgent_Connect_Stop(String UID);
	public native int  P2PTunnelAgent_Connect_Stop_Parallel(String UID, int SID);
	public native int  P2PTunnelAgent_Attach_Connect_Stop(int SID, int CHID);
	public native int  P2PTunnelAgent_Disconnect(int SID);
	public native int  P2PTunnelAgent_PortMapping(int SID, int localPort, int remotePort);
	public native int  P2PTunnelAgent_ServiceMapping(int SID, int localPort, String serviceID);
	public native void P2PTunnelAgent_StopPortMapping(int index);
	public native void P2PTunnelAgent_ServiceMapping(int index);
	public native int  P2PTunnelAgent_StopPortMapping_byIndexArray(int[] indexArray, int indexNum);
	public native int  P2PTunnelAgent_Abort(int SID);
	public native void P2PTunnelAgent_Set_Log_Path(String path, int nMaxSize);
	public native int  P2PTunnel_Set_Connection_Option(st_ConnectOption S_ConnectOption);

	public native int  P2PTunnelSetConnectionOption(P2PTunnelConnectionType type);
	public native int  P2PTunnelServer_Register_Port_Verify(tunnelServerPortVerifyCB tunnelServerPortVerifyFn, Object userArg);
	public native int  P2PTunnelServer_Register_Service_Verify(tunnelServerServiceVerifyCB tunnelServerServiceVerifyFn, Object userArg);
	public native int  P2PTunnelServer_Listen(int SID, int CHID);
	@Deprecated public native int  P2PTunnelAgent_Attach_Connect(int SID, int CHID, byte[] authData, int authDataLength, int[] errFromDeviceCB);

	public native int  P2PTunnelServer_Start_Ex(String UID, tunnelServerAuthCB tunnelServerAuthFn, tunnelSessionInfoExCB sessionInfoExFn, Object userArg);
	public native int  P2PTunnelAgent_Connect_Ex(String UID, tunnelAgentAuthCB tunnelAgentAuthFn, Object userArg);
	public native int  P2PTunnelAgent_Connect_Parallel_Ex(String UID, int SID, tunnelAgentAuthCB tunnelAgentAuthFn, Object userArg);
	public native int  P2PTunnelAgent_Attach_Connect_Ex(int SID, int CHID, tunnelAgentAuthCB tunnelAgentAuthFn, Object userArg);

	public native int  P2PTunnelServer_Start_By_Nebula(long deviceCtx, tunnelSessionInfoExCB sessionInfoExFn, Object userArg);
	public native int  P2PTunnelAgent_Connect_By_Nebula(long clientCtx, String amToken, String realm, int timeoutMs);
	public native int  P2PTunnelAgent_Connect_By_Nebula_Ex(long clientCtx, String validation, String realm, int timeoutMs);
	public native int  P2PTunnelAgent_Connect_Stop_By_Nebula(long clientCtx);

	public P2PTunnelAPIs(IP2PTunnelCallback obj){
		mSelf = obj; 
	}
	
	public void tunnelStatusCB(int nErrorCode, int nSID) { //Callback function affects both the P2PTunnelServer and the P2PTunnelAgent
		if(mSelf != null) 
			mSelf.onTunnelStatusChanged(nErrorCode, nSID);
	}	
	
	public int tunnelSessionInfoCB(sP2PTunnelSessionInfo sSessionInfo) { //Callback function affects only the P2PTunnelServer.
		if (mSelf != null) {
			return mSelf.onTunnelSessionInfoChanged(sSessionInfo);
		}
		
		return 0;
	}
    
	public interface IP2PTunnelCallback {
		public void onTunnelStatusChanged(int nErrCode, int nSID);
		public int onTunnelSessionInfoChanged(sP2PTunnelSessionInfo object);
	}
	
	public interface tunnelServerAuthCB {
		void onTunnelServerAuth(String account, String[] password, Object userArg);
	}

	public interface tunnelServerPortVerifyCB {
		int onTunnelServerPortVerify(int nServicePort, Object userArg);
	}

	public interface tunnelServerServiceVerifyCB {
		int onTunnelServerServiceVerify(String serviceID, Object userArg);
	}
	
	public interface tunnelAgentAuthCB {
        void onTunnelAgentAuth(String[] account, String[] password, Object userArg);
	}

	public interface tunnelSessionInfoExCB {
        void onTunnelSessionInfoExChanged(sP2PTunnelSessionInfoEx object, Object userArg);
	}

    static {
        LoadLibrary.load("P2PTunnelAPIs");
    }
}
